import { hasElementSourceMap, toValue } from '@swagger-api/apidom-core';
import RelativeJsonPointerError from "./RelativeJsonPointerError.mjs";
class EvaluationRelativeJsonPointerError extends RelativeJsonPointerError {
  constructor(message, structuredOptions) {
    super(message, structuredOptions);
    if (typeof structuredOptions !== 'undefined') {
      this.relativePointer = structuredOptions.relativePointer;
      this.currentElement = structuredOptions.currentElement.element;
      if (hasElementSourceMap(structuredOptions.currentElement)) {
        this.currentElementSourceMap = toValue(structuredOptions.currentElement.getMetaProperty('sourceMap'));
      }
      this.rootElement = structuredOptions.rootElement.element;
      if (hasElementSourceMap(structuredOptions.rootElement)) {
        this.rootElementSourceMap = toValue(structuredOptions.rootElement.getMetaProperty('sourceMap'));
      }
      if (typeof structuredOptions.cursorElement !== 'undefined') {
        this.cursorElement = structuredOptions.cursorElement.element;
        if (hasElementSourceMap(structuredOptions.cursorElement)) {
          this.cursorElementSourceMap = toValue(structuredOptions.cursorElement.getMetaProperty('sourceMap'));
        }
      }
    }
  }
}
export default EvaluationRelativeJsonPointerError;